<?php
/**
 * Plugin Acces restreints Giseh 
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/headers');

/**
 * Protection par filtre d'acces
 * Filtre d'acces aux documents joints et aux images joints (hors logos)
 * 
 * @return boolean
 */
if(!function_exists('action_acceder_vignette')) {
function action_acceder_vignette() {
    
        // couplage avec CIFILTRE
        if (defined('_DIR_PLUGIN_CIFILTRE')) {
        	if (!isset($GLOBALS['visiteur_session']['id_auteur'])) {
                        include_spip('cifiltre_pipeline');

                        // si on n'est pas connecte et qu'on est filtre on se redirige vers l'authentification
                        if (cifiltre_ip_site_public('sommaire') OR cifiltre_host_site_public('sommaire')) {
                                include_spip('inc/headers');
                                redirige_par_entete(generer_url_public('login', 'url='.rawurlencode(parametre_url(self(), 'var_mode', $_GET['var_mode'], '&')), true));
                        }
                }
        }
    
	include_spip('inc/documents');

        $request_file = _request('file'); 
        if (empty($request_file)){
            $f = '';
            $file = '';
        } else {
            // $file exige pour eviter le scan id_document par id_document
            $f = rawurldecode($request_file);

            // enlever le timestamp eventuel
            $f = preg_replace(',[?][0-9]+$,','',$f);

            $file = _DIR_VAR.'cache-vignettes/'.$f;
        }
        
	$arg = rawurldecode(_request('arg'));

        if ($GLOBALS['spip_version_branche']>=4) {
            $ci_dir_logos = _DIR_IMG . "logo/";
        } else {    
            $ci_dir_logos = _DIR_LOGOS;
        }
        

	$niveau_acces = "";
	$status = $dcc = false;
	if (strpos($f,'../') !== false
	OR preg_match(',^\w+://,', $f)) {
		$status = 403;
	}
	elseif (!file_exists($file) OR !is_readable($file)) {
		$status = 404;
	} else {
                list($id_document,$taille1) = explode('/', $arg);
                list($taille2,$fichier) = explode('/', $f);

                if ($taille1 != $taille2){
                    $status = 403;
                } else {
                    $nom = substr($fichier,0,-10);
                    $extension = substr($fichier,-3);
                    $nom_et_ext1 = $nom.'.'.$extension;
                    if ($extension=='jpg'){
                        $nom_et_ext2 = $nom.'.png';
                        $nom_et_ext3 = $nom.'.gif';
                    } elseif ($extension=='png'){
                        $nom_et_ext2 = $nom.'.jpg';
                        $nom_et_ext3 = $nom.'.gif';
                    } else {
                        $nom_et_ext2 = $nom.'.jpg';
                        $nom_et_ext3 = $nom.'.png';
                    }
                    
                    // cas d'une vignette par defaut (pdf.png, etc.)
                    if (find_in_path("prive/vignettes/".$nom.".png")){
                        
                            // ETag pour gerer le status 304
                            $ETag = md5($file . ': '. filemtime($file));
                            if (isset($_SERVER['HTTP_IF_NONE_MATCH'])
                            AND $_SERVER['HTTP_IF_NONE_MATCH'] == $ETag) {
                                    http_status(304); // Not modified
                                    exit;
                            }
                            
                    // cas d'une image de SPIP, d'une icone de plugin, etc.
                    // remarque : la vignette peut avoir une extension differente
                    } elseif (chemin_image($nom_et_ext1) 
                            OR chemin_image($nom_et_ext2) 
                            OR chemin_image($nom_et_ext3)){
                    
                            // ETag pour gerer le status 304
                            $ETag = md5($file . ': '. filemtime($file));
                            if (isset($_SERVER['HTTP_IF_NONE_MATCH'])
                            AND $_SERVER['HTTP_IF_NONE_MATCH'] == $ETag) {
                                    http_status(304); // Not modified
                                    exit;
                            }
                            
                    // un logo d'article, ..., peut avoir une copie reduite dans cache-vignettes
                    // remarque : la vignette peut avoir une extension differente
                    } elseif (@file_exists($d = ($ci_dir_logos . $nom_et_ext1)) 
                            OR @file_exists($d = ($ci_dir_logos . $nom_et_ext2))
                            OR @file_exists($d = ($ci_dir_logos . $nom_et_ext3))
                            ) {
                            $ci_type_objet = '';
                            $ci_id_objet = 0;
                            $id_rubrique = 0;
                            $niveau_acces = 'libre';
                            
                            // trouver l'objet et son id 
                            if ($GLOBALS['spip_version_branche']>=4) {
                                $ci_id_logo = sql_getfetsel('id_document', 'spip_documents', "(mode='logoon' OR mode='logooff')  AND fichier='logo/".basename($d)."'");
                                $ci_logo_objet = sql_fetsel('*', 'spip_documents_liens', "id_document=".intval($ci_id_logo));
                    		if ($ci_logo_objet) {
                                    $ci_type_objet = $ci_logo_objet['objet'];
                                    $ci_id_objet = $ci_logo_objet['id_objet'];
                                }
                            } else {
                                $ci_table_logos = array('arton'=>'article','rubon'=>'rubrique','siteon'=>'site','breveon'=>'breve',
                                    'artoff'=>'article','ruboff'=>'rubrique','siteoff'=>'site','breveoff'=>'breve');

                                foreach ($ci_table_logos as $cle=>$valeur) {
                                    if (substr($nom,0,strlen($cle))==$cle 
                                            AND intval(substr($nom,strlen($cle)))>0 ){
                                        $ci_type_objet = $valeur;
                                        $ci_id_objet = intval(substr($nom,strlen($cle)));
                                        break;
                                    }
                                }
                            }
                            
                            // ETag pour gerer le status 304
                            $ETag = md5($file . ': '. filemtime($file));
                            if (isset($_SERVER['HTTP_IF_NONE_MATCH'])
                            AND $_SERVER['HTTP_IF_NONE_MATCH'] == $ETag) {
                                    http_status(304); // Not modified
                                    exit;
                            }

                            if ($ci_type_objet AND $ci_id_objet>0) {
                                    // quelle est la rubrique de l'objet ?
                                    switch($ci_type_objet) {

                                    case 'article':
                                            $id_rubrique = sql_getfetsel("id_rubrique", "spip_articles", "id_article=".$ci_id_objet);
                                            break;
                                    
                                    case 'rubrique':
                                            $id_rubrique = $ci_id_objet;
                                            break;
                                        
                                    case 'site':
                                            $id_rubrique = sql_getfetsel("id_rubrique", "spip_syndic", "id_syndic=".$ci_id_objet);
                                            break;
                                    
                                    case 'breve':
                                            $id_rubrique = sql_getfetsel("id_rubrique", "spip_breves", "id_breve=".$ci_id_objet);
                                            break;
                                    }
                                    
                                    // Verifier les droits d'acces a l'objet
                                    include_spip('ciar_fonctions');
                                    if ($id_rubrique>0) {
                                        if ((!isset($GLOBALS['visiteur_session']['id_auteur']) AND ciar_rub_ar($id_rubrique)) 
                                         OR ciar_rubrique_interdite($id_rubrique))
                                            $niveau_acces = 'interdit';
                                        else
                                            $niveau_acces = 'autorise';
                                            
                                    }
                                    
                                    if ($niveau_acces=='interdit')
                                            $status = 403;
                            }
                            
                    // cas general
                    } else {
                            $where = "id_document=".intval($id_document)." AND "
                            .sql_in("fichier", array(
                            substr($nom_et_ext1,-3).'/'.$nom_et_ext1,
                            substr($nom_et_ext2,-3).'/'.$nom_et_ext2,
                            substr($nom_et_ext3,-3).'/'.$nom_et_ext3
                            ));

                            $vignette = sql_fetsel("id_document, titre, fichier, extension, mode", "spip_documents",$where);
                            $doc = '';
                            if ($vignette) {
                                // cas d'une vignette personnalisee
                                if ($vignette['mode']=='vignette'){
                                    $doc = sql_fetsel("id_document, titre, fichier, extension", "spip_documents","id_vignette=".intval($vignette['id_document']));
                                } else {
                                    $doc = $vignette;
                                }                    
                            }
                    
                            if (!$doc) {
                                    $status = 404;
                            } else {
                                    $ext = $doc['extension'];
                                    $type = sql_fetsel("mime_type, inclus", "spip_types_documents","extension='".$ext."'");

                                    // ETag pour gerer le status 304
                                    $ETag = md5($file . ': '. filemtime($file));
                                    if (isset($_SERVER['HTTP_IF_NONE_MATCH'])
                                    AND $_SERVER['HTTP_IF_NONE_MATCH'] == $ETag) {
                                            http_status(304); // Not modified
                                            exit;
                                    }
                                    // Verifier les droits d'acces au document
                                    include_spip('ciar_fonctions');
                                    $niveau_acces = ciar_acces_document($doc['id_document']);
                                    if ($niveau_acces=='interdit')
                                            $status = 403;

                            }
                    }
                }
	}

	switch($status) {

	case 403:
		include_spip('inc/minipres');
		echo minipres();
		break;

	case 404:
		http_status(404);
		include_spip('inc/minipres');
		echo minipres(_T('erreur').' 404',
			_T('info_document_indisponible'));
		break;

	default:
		header("Content-Type: ". $type['mime_type']);

		// pour les images ne pas passer en attachment
		// sinon, lorsqu'on pointe directement sur leur adresse,
		// le navigateur les downloade au lieu de les afficher

		if ($type['inclus']=='non' AND !(defined('_CIAR_DOC_PAS_ATTACHE') AND _CIAR_DOC_PAS_ATTACHE=='oui')) {

		  // Si le fichier a un titre avec extension,
		  // ou si c'est un nom bien connu d'Unix, le prendre
		  // sinon l'ignorer car certains navigateurs pataugent

			$f = basename($file);
			if (isset($doc['titre'])
				AND (preg_match('/^\w+[.]\w+$/', $doc['titre']) OR $doc['titre'] == 'Makefile'))
				$f = $doc['titre'];

			// ce content-type est necessaire pour eviter des corruptions de zip dans ie6
			header('Content-Type: application/octet-stream');

			header("Content-Disposition: attachment; filename=\"$f\";");
			header("Content-Transfer-Encoding: binary");

			if ($niveau_acces=='libre') {
				// fix for IE catching or PHP bug issue
				header("Pragma: public");
				header("Expires: 0"); // set expiration time
				header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			}
		}

		if ($niveau_acces=='libre') {
			// ETag pour gerer le status 304
			header('ETag: '.$ETag);
		}
		
		if ($niveau_acces=='autorise') {
			header("Pragma: no-cache");
			header("Expires: 0");
			header("Cache-Control: no-store, no-cache, must-revalidate");
		}	

		if ($cl = filesize($file))
			header("Content-Length: ". $cl);

		readfile($file);
		break;
	}

}
}

?>